--------------------------------------------------------------------------------
-- Company: FSU-FAMU
-- Engineer: Dr. Uwe Meyer-Baese
-- Create Date:    6:29 01/06/11
-- Design Name:    seg7_LUT 
-- Target Device:   EP2C35F672C6
-- Tool versions:   Quartus II 9.1
-- Description:   This is a 4 bit to seven segement decoder
--                to generate 0,1,2,3,4,5,6,7,8,9,a,b,c,d,e,f
-- Resources used:
--  Total Number LEs: 7
--  Number of 9x9 Mults: 0
--  Number of Embedded 4Ks: 0
--  Maximum Delay N/A MHz (no register)
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;
--------------------------------------------------------------------------------
ENTITY seg7_LUT IS
  PORT(idig : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
       oseg : OUT STD_LOGIC_VECTOR(6 DOWNTO 0));          
END ENTITY seg7_LUT;

ARCHITECTURE fpga OF seg7_LUT IS
BEGIN
  P1: PROCESS(idig) -- active low, LED on for zero output
  BEGIN
    CASE conv_integer(idig) IS 
                     -- GFEDCBA 
    WHEN 1  => oseg <= "1111001";   -- ---A---
    WHEN 2  => oseg <= "0100100";   -- |      |
    WHEN 3  => oseg <= "0110000";   -- F      B
    WHEN 4  => oseg <= "0011001";   -- |      |
    WHEN 5  => oseg <= "0010010";   -- ---G----
    WHEN 6  => oseg <= "0000010";   -- |      |
    WHEN 7  => oseg <= "1111000";   -- E      C
    WHEN 8  => oseg <= "0000000";   -- |      |
    WHEN 9  => oseg <= "0011000";   -- ---D----
    WHEN 10 => oseg <= "0100011"; --a
    WHEN 11 => oseg <= "0000011"; --b
    WHEN 12 => oseg <= "0100111"; --c
    WHEN 13 => oseg <= "0100001"; --d
    WHEN 14 => oseg <= "0000100"; --e
    WHEN 15 => oseg <= "0001110"; --f
    WHEN OTHERS => oseg <= "1000000";
    END CASE;
  END PROCESS;

END ARCHITECTURE fpga;

